"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolve = exports.reject = exports.findLinkByValue = exports.findPromise = exports.awaitPromise = void 0;
const global_ids_1 = require("./global-ids");
const gql_1 = require("./gql");
function awaitPromise(options) {
    const id = options.id;
    const client = options.client;
    return new Promise((res, rej) => {
        const subscription = client.subscribe((0, gql_1.generateQuery)({
            queries: [(0, gql_1.generateQueryData)({ tableName: 'links', returning: `
        id type { id value }
      `, variables: {
                        where: {
                            _or: [
                                { id: { _eq: id } },
                                { from_id: id, type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_THEN } } } },
                                { from: { type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_PROMISE } } }, in: { type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_THEN } } }, from_id: { _eq: id } } }, _or: [
                                        { type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_RESOLVED } } } },
                                        { type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_REJECTED } } } },
                                    ] },
                            ],
                        },
                    } })],
            name: 'PROMISE',
        }));
        const observing = subscription.subscribe((result) => {
            var _a, _b, _c, _d, _e, _f, _g;
            if (result === null || result === void 0 ? void 0 : result.errors)
                rej(result === null || result === void 0 ? void 0 : result.errors);
            else if (result === null || result === void 0 ? void 0 : result.data) {
                const links = (_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a.q0;
                if (links.length) {
                    let thenExists = false;
                    let thenResolved = false;
                    let thenRejected = false;
                    for (let l = 0; l < links.length; l++) {
                        const link = links[l];
                        if (((_c = (_b = link === null || link === void 0 ? void 0 : link.type) === null || _b === void 0 ? void 0 : _b.value) === null || _c === void 0 ? void 0 : _c.value) === global_ids_1.GLOBAL_NAME_THEN)
                            thenExists = true;
                        else if (((_e = (_d = link === null || link === void 0 ? void 0 : link.type) === null || _d === void 0 ? void 0 : _d.value) === null || _e === void 0 ? void 0 : _e.value) === global_ids_1.GLOBAL_NAME_RESOLVED)
                            thenResolved = true;
                        else if (((_g = (_f = link === null || link === void 0 ? void 0 : link.type) === null || _f === void 0 ? void 0 : _f.value) === null || _g === void 0 ? void 0 : _g.value) === global_ids_1.GLOBAL_NAME_REJECTED)
                            thenRejected = true;
                    }
                    if (thenExists) {
                        if (thenResolved && !thenRejected) {
                            observing.unsubscribe();
                            res(true);
                        }
                        else if (thenRejected) {
                            observing.unsubscribe();
                            rej(false);
                        }
                    }
                    else
                        observing.unsubscribe();
                }
            }
        });
    });
}
exports.awaitPromise = awaitPromise;
;
function findPromise(options) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield this.client.query((0, gql_1.generateQuery)({
            queries: [
                (0, gql_1.generateQueryData)({ tableName: 'links', returning: `id`, variables: { where: {
                            type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_PROMISE } } },
                            in: {
                                type: { value: { _contains: { value: global_ids_1.GLOBAL_NAME_THEN } } },
                                from_id: options.id,
                            },
                        } } }),
            ],
            name: 'FIND_PROMISE',
        }));
        return (_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a.q0;
    });
}
exports.findPromise = findPromise;
function findLinkByValue(options, value) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield this.client.query((0, gql_1.generateQuery)({
            queries: [
                (0, gql_1.generateQueryData)({ tableName: 'links', returning: `id`, variables: { where: {
                            value: { _contains: { value: value } },
                        } } }),
            ],
            name: 'FIND_LINK_BY_VALUE',
        }));
        return (_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a.q0;
    });
}
exports.findLinkByValue = findLinkByValue;
function reject(options) {
    return __awaiter(this, void 0, void 0, function* () {
        const rej = yield findLinkByValue(options, global_ids_1.GLOBAL_NAME_REJECTED);
        const promise = yield findPromise(options);
        if (promise) {
            yield options.client.mutate((0, gql_1.generateSerial)({
                actions: [(0, gql_1.insertMutation)('links', { objects: { type_id: rej.id, from_id: promise.id, to_id: promise.id } })],
                name: 'REJECT',
            }));
            return true;
        }
        return false;
    });
}
exports.reject = reject;
function resolve(options) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield findLinkByValue(options, global_ids_1.GLOBAL_NAME_RESOLVED);
        const promise = yield findPromise(options);
        if (promise) {
            yield options.client.mutate((0, gql_1.generateSerial)({
                actions: [(0, gql_1.insertMutation)('links', { objects: { type_id: res.id, from_id: promise.id, to_id: promise.id } })],
                name: 'RESOLVE',
            }));
            return true;
        }
        return false;
    });
}
exports.resolve = resolve;
//# sourceMappingURL=promise.js.map